roboptim::GenericFiniteDifferenceGradient< T, FdgPolicy > Class Template Reference
Mathematical functions

Compute automatically a gradient with finite differences. More...

`#include <roboptim/core/fwd.hh>`

Inheritance diagram for roboptim::GenericFiniteDifferenceGradient< T, FdgPolicy >:

## Public Member Functions

| ROBOPTIM_DIFFERENTIABLE_FUNCTION_FWD_TYPEDEFS_ (GenericDifferentiableFunction< T >)
| GenericFiniteDifferenceGradient (const GenericFunction< T > &f, value_type e=finiteDifferenceEpsilon) throw ()
| Instantiate a finite differences gradient. More...
| ~GenericFiniteDifferenceGradient () throw ()
Public Member Functions inherited from roboptim::GenericDifferentiableFunction< T >
| ROBOPTIM_FUNCTION_FWD_TYPEDEFS_ (GenericFunction< T >)
size_type | gradientSize () const throw ()
| Return the gradient size. More...
jacobianSize_t | jacobianSize () const throw ()
| Return the jacobian size as a pair. More...
bool | isValidGradient (const gradient_t &gradient) const throw ()
| Check if the gradient is valid (check size). More...
bool | isValidJacobian (const jacobian_t &jacobian) const throw ()
| Check if the jacobian is valid (check sizes). More...
jacobian_t | jacobian (const argument_t &argument) const throw ()
| Computes the jacobian. More...
void | jacobian (jacobian_t &jacobian, const argument_t &argument) const throw ()
| Computes the jacobian. More...
gradient_t | gradient (const argument_t &argument, size_type functionId=0) const throw ()
| Computes the gradient. More...
void | gradient (gradient_t &gradient, const argument_t &argument, size_type functionId=0) const throw ()
| Computes the gradient. More...
virtual std::ostream & | print (std::ostream &o) const throw ()
| Display the function on the specified output stream. More...
Public Member Functions inherited from roboptim::GenericFunction< T >
bool | isValidResult (const result_t &result) const throw ()
| Check the given result size is valid. More...
GenericFunction< T >::size_type | inputSize () const throw ()
| Return the input size (i.e. More...
GenericFunction< T >::size_type | outputSize () const throw ()
| Return the output size (i.e. More...
virtual | ~GenericFunction () throw ()
| Trivial destructor. More...
result_t | operator() (const argument_t &argument) const throw ()
| Evaluate the function at a specified point. More...
void | operator() (result_t &result, const argument_t &argument) const throw ()
| Evaluate the function at a specified point. More...
const std::string & | getName () const throw ()
| Get function name. More...

## Protected Member Functions

void | impl_compute (result_t &, const argument_t &) const throw ()
| Function evaluation. More...
void | impl_gradient (gradient_t &, const argument_t &argument, size_type=0) const throw ()
| Gradient evaluation. More...
Protected Member Functions inherited from roboptim::GenericDifferentiableFunction< T >
| GenericDifferentiableFunction (size_type inputSize, size_type outputSize=1, std::string name=std::string()) throw ()
| Concrete class constructor should call this constructor. More...
virtual void | impl_jacobian (jacobian_t &jacobian, const argument_t &arg) const throw ()
| Jacobian evaluation. More...
template<>
void | impl_jacobian (jacobian_t &jacobian, const argument_t &argument) const throw()
Protected Member Functions inherited from roboptim::GenericFunction< T >
| GenericFunction (size_type inputSize, size_type outputSize=1, std::string name=std::string()) throw ()
| Concrete class constructor should call this constructor. More...

## Protected Attributes

const GenericFunction< T > & | adaptee_
| Reference to the wrapped function. More...
const value_type | epsilon_
argument_t | xEps_

## Additional Inherited Members

Public Types inherited from roboptim::GenericDifferentiableFunction< T >
typedef GenericFunctionTraits< T >::gradient_t | gradient_t
| Gradient type. More...
typedef GenericFunctionTraits< T >::jacobian_t | jacobian_t
| Jacobian type. More...
typedef std::pair< size_type, size_type > | jacobianSize_t
| Jacobian size type (pair of values). More...
Public Types inherited from roboptim::GenericFunction< T >
typedef GenericFunctionTraits< T >::value_type | value_type
| Values type. More...
typedef GenericFunctionTraits< T >::vector_t | vector_t
| Basic vector type. More...
typedef GenericFunctionTraits< T >::matrix_t | matrix_t
| Basic matrix type. More...
typedef GenericFunctionTraits< T >::size_type | size_type
| Size type. More...
typedef GenericFunctionTraits< T >::result_t | result_t
| Type of a function evaluation result. More...
typedef GenericFunctionTraits< T >::argument_t | argument_t
| Type of a function evaluation argument. More...
typedef std::pair< value_type, value_type > | interval_t
| Interval type (lower, upper). More...
typedef std::vector< interval_t > | intervals_t
| Vector of intervals. More...
typedef boost::tuple< value_type, value_type, value_type > | discreteInterval_t
| Types representing a discrete interval. More...
Static Public Member Functions inherited from roboptim::GenericFunction< T >
static value_type | epsilon () throw ()
| Get the value of the machine epsilon, useful for floating types comparison. More...
static value_type | infinity () throw ()
| Get the value that symbolizes positive infinity. More...
static interval_t | makeInterval (value_type l, value_type u) throw ()
| Construct an interval from a lower and upper bound. More...
static interval_t | makeInfiniteInterval () throw ()
| Construct an infinite interval. More...
static interval_t | makeLowerInterval (value_type l) throw ()
| Construct an interval from a lower bound. More...
static interval_t | makeUpperInterval (value_type u) throw ()
| Construct an interval from an upper bound. More...
static double | getLowerBound (const interval_t &interval) throw ()
| Get the lower bound of an interval. More...
static double | getUpperBound (const interval_t &interval) throw ()
| Get the upper bound of an interval. More...
static discreteInterval_t | makeDiscreteInterval (value_type min, value_type max, value_type step)
| Construct a discrete interval. More...
static discreteInterval_t | makeDiscreteInterval (interval_t interval, value_type step)
| Construct a discrete interval. More...
static double | getLowerBound (const discreteInterval_t &interval) throw ()
| Get the lower bound of a discrete interval. More...
static double | getUpperBound (const discreteInterval_t &interval) throw ()
| Get the upper bound of a discrete interval. More...
static double | getStep (const discreteInterval_t &interval) throw ()
| Get the upper step of a discrete interval. More...
template<typename F >
static void | foreach (const discreteInterval_t interval, F functor)
| Iterate on an interval. More...
template<typename F >
static void | foreach (const interval_t interval, const size_type n, F functor)
| Iterate on an interval. More...
Static Protected Attributes inherited from roboptim::GenericFunction< T >
static log4cxx::LoggerPtr | logger
| Pointer to function logger (see log4cxx documentation). More...

## Detailed Description

### template<typename T, typename FdgPolicy>
class roboptim::GenericFiniteDifferenceGradient< T, FdgPolicy >

Compute automatically a gradient with finite differences.

Finite difference gradient is a method to approximate a function's gradient. It is particularly useful in RobOptim to avoid the need to compute the analytical gradient manually.

This class takes a Function as its input and wraps it into a derivable function.

The one dimensional formula is:

where is a constant given when calling the class constructor.

Examples:
  finite-difference-gradient.cc.

## Constructor & Destructor Documentation

template<typename T, typename FdgPolicy>

roboptim::GenericFiniteDifferenceGradient< T, FdgPolicy >::GenericFiniteDifferenceGradient | ( | const GenericFunction< T > & | f,
|  | value_type | e = `finiteDifferenceEpsilon`
| ) |  |
throw | ( |
| ) |  |

Instantiate a finite differences gradient.

Instantiate a derivable function that will wraps a non derivable function and compute automatically its gradient using finite differences.

Parameters

  f | function that will e wrapped
  e | epsilon used in finite difference computation

template<typename T , typename FdgPolicy >

roboptim::GenericFiniteDifferenceGradient< T, FdgPolicy >::~GenericFiniteDifferenceGradient | ( |  | ) |
throw | ( |
| ) |  |

## Member Function Documentation

template<typename T , typename FdgPolicy >

void roboptim::GenericFiniteDifferenceGradient< T, FdgPolicy >::impl_compute | ( | result_t & | result,
|  | const argument_t & | argument
| ) |  | const
throw | ( |
| ) |  |

protected virtual

Function evaluation.

Evaluate the function, has to be implemented in concrete classes.

Warning
  Do not call this function directly, call operator()(result_t&, const argument_t&) const throw () instead.

Parameters

  result | result will be stored in this vector
  argument | point at which the function will be evaluated

Implements roboptim::GenericFunction< T >.

template<typename T , typename FdgPolicy >

void roboptim::GenericFiniteDifferenceGradient< T, FdgPolicy >::impl_gradient | ( | gradient_t & | gradient,
|  | const argument_t & | argument,
|  | size_type | functionId = `0`
| ) |  | const
throw | ( |
| ) |  |

protected virtual

Gradient evaluation.

Compute the gradient, has to be implemented in concrete classes. The gradient is computed for a specific sub-function which id is passed through the functionId argument.

Warning
  Do not call this function directly, call gradient instead.

Parameters

  gradient | gradient will be store in this argument
  argument | point where the gradient will be computed
  functionId | evaluated function id in the split representation

ROBOPTIM_DO_NOT_CHECK_ALLOCATION

Implements roboptim::GenericDifferentiableFunction< T >.

template<typename T, typename FdgPolicy>

roboptim::GenericFiniteDifferenceGradient< T, FdgPolicy >::ROBOPTIM_DIFFERENTIABLE_FUNCTION_FWD_TYPEDEFS_ | ( | GenericDifferentiableFunction< T > |  | ) |

## Member Data Documentation

template<typename T, typename FdgPolicy>

const GenericFunction<T>& roboptim::GenericFiniteDifferenceGradient< T, FdgPolicy >::adaptee_

protected

Reference to the wrapped function.

template<typename T, typename FdgPolicy>

const value_type roboptim::GenericFiniteDifferenceGradient< T, FdgPolicy >::epsilon_

protected

template<typename T, typename FdgPolicy>

argument_t roboptim::GenericFiniteDifferenceGradient< T, FdgPolicy >::xEps_

mutable protected